import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.filechooser.*;
import java.io.*;



public class JPaint extends JFrame implements ActionListener, IGraphicAction {
	GrfPanel grafik;
	JList grfliste;
	JButton BnOpen;
	JButton BnSave;
	JToggleButton BnNone; // Wechselschalter
	JToggleButton BnLine;
	JToggleButton BnCircle;
	JToggleButton BnRect;
	JButton BnTest;
	// Popupmenues lk=lokal
	JMenuItem lkTop;
	JMenuItem lkDown;
	JMenuItem lkFlash;
	JMenuItem lkDelete;
	JMenuItem lkDeleteAll;

	Timer myTimer = null;
	int anzTimer = 0;
	String sFileName;

	Vector<GObject> liste;

	public JPaint(String title) {
		super.setTitle(title);
		super.setVisible(true);
		super.setSize(800, 600);
		super.setLocation(10, 20);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		liste = new Vector<GObject>();
		setGUI();
	}

	private void setGUI() {
		JPanel bnPanel = new JPanel();
		BnOpen = new JButton("Open");
		BnSave = new JButton("Save");
		bnPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		bnPanel.add(BnOpen);
		bnPanel.add(BnSave);
		BnNone = new JToggleButton("Nichts");
		BnLine = new JToggleButton("Linie");
		BnCircle = new JToggleButton("Kreis");
		BnRect = new JToggleButton("Rechteck");
		BnTest = new JButton("Test");
		bnPanel.add(BnNone);
		bnPanel.add(BnLine);
		bnPanel.add(BnCircle);
		bnPanel.add(BnRect);
		bnPanel.add(BnTest);

		BnOpen.setFont(new Font("Arial", Font.BOLD, 18));
		BnSave.setFont(new Font("Arial", Font.BOLD, 18));
		BnNone.setFont(new Font("Arial", Font.BOLD, 18));
		BnLine.setFont(new Font("Arial", Font.BOLD, 18));
		BnCircle.setFont(new Font("Arial", Font.BOLD, 18));
		BnRect.setFont(new Font("Arial", Font.BOLD, 18));
		BnTest.setFont(new Font("Arial", Font.BOLD, 18));

		// ToggleButton in eine Gruppe setzen
		ButtonGroup group1;
		group1 = new ButtonGroup();
		group1.add(BnNone);
		group1.add(BnLine);
		group1.add(BnCircle);
		group1.add(BnRect);

		// Maus-Click abfangen und auswerten
		BnOpen.addActionListener(this);
		BnSave.addActionListener(this);
		BnNone.addActionListener(this);
		BnLine.addActionListener(this);
		BnCircle.addActionListener(this);
		BnRect.addActionListener(this);
		BnTest.addActionListener(this);

		this.setLayout(new BorderLayout());
		getContentPane().add(bnPanel, BorderLayout.NORTH);

		grafik = new GrfPanel(liste, this);
		grfliste = new JList();
		grfliste.setFont(new Font("Arial", Font.BOLD, 14));
		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, false,
				grfliste, grafik);
		this.getContentPane().add(split, BorderLayout.CENTER);
		split.setDividerLocation(150);
		grafik.updateUI();
		grfliste.updateUI();
		split.updateUI();

		grfliste.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				grfliste_Clicked(e);
			}
		});
	} // setGUI

	public int getButton(MouseEvent e) {
		int mode = e.getModifiers();
		if ((mode & e.BUTTON1_MASK) > 0) {
			return 1;
		}
		if ((mode & e.BUTTON2_MASK) > 0) {
			return 2;
		}
		if ((mode & e.BUTTON3_MASK) > 0) {
			return 3;
		}
		return 0;
	} // getButton

	private void grfliste_Clicked(MouseEvent e) {
		// Doppelklick mit linker Maustaste
		if (e.getClickCount() == 2 && getButton(e) == 1) {
			if (liste.size() > 0) {
				GObject item = liste.get(grfliste.getSelectedIndex());
				if (item.showEdit())
					grafik.updateUI();
			}
		}
		// Einfachklick mit rechter Maustaste
		if (e.getClickCount() == 1 && getButton(e) == 3) {
			System.out.println("Rechte Maustaste");
			if ((liste.size() > 0) && (grfliste.getSelectedIndex() >= 0)) {
				popupEditMenu(e); // IGrafik item = liste.get(
									// grfliste.getSelectedIndex() );
			}
		}
	} // grfliste_Clicked

	// Popup-Menue fuer Kopieren Oeffnen und Loeschen
	public void popupEditMenu(MouseEvent me) {
		if (myTimer == null) {
			JPopupMenu popup = new JPopupMenu();
			// Meneueintag Nach oben
			lkTop = new JMenuItem("Nach oben");
			lkTop.addActionListener(this);
			popup.add(lkTop);

			lkDown = new JMenuItem("Nach unten");
			lkDown.addActionListener(this);
			popup.add(lkDown);

			popup.addSeparator();
			lkDelete = new JMenuItem("Lschen");
			lkDelete.addActionListener(this);
			popup.add(lkDelete);

			popup.addSeparator();
			lkDeleteAll = new JMenuItem("Alles Lschen");
			lkDeleteAll.addActionListener(this);
			popup.add(lkDeleteAll);

			popup.addSeparator();
			lkFlash = new JMenuItem("Blinkend");
			lkFlash.addActionListener(this);
			popup.add(lkFlash);

			popup.show(me.getComponent(), me.getX(), me.getY());
		}
	}// popupMenu

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == BnOpen) {
			openFile();
		}
		if (e.getSource() == BnSave) {
			saveFile();
		}
		if (e.getSource() == BnNone) {
			if (BnNone.isSelected()) {

				grafik.bAction = false;
			}
		}
		if (e.getSource() == BnLine) {
			if (BnLine.isSelected()) {

				grafik.bAction = true;
			}
		}
		if (e.getSource() == BnCircle) {
			if (BnCircle.isSelected()) {

				grafik.bAction = true;
			}
		}
		if (e.getSource() == BnRect) {
			if (BnRect.isSelected()) {

				grafik.bAction = true;
			}
		}

		if (e.getSource() == BnTest) {
			System.out.println("Test");
			Test();
		}
		if (e.getSource() == lkTop) {
			ChangeTop();
		}

		if (e.getSource() == lkDown) {
			ChangeDown();
		}

		if (e.getSource() == lkFlash) {
			ChangeFlash();
		}
		if (e.getSource() == myTimer) {
			setTimer();
		}
		if (e.getSource() == lkDelete) {
			deleteItem();
		}
		if (e.getSource() == lkDeleteAll) {
			liste.clear();
			grfliste.removeAll();
			grfliste.updateUI();
		}

	} // actionPerformed

	// Timer fuer das Blinken
	private void setTimer() {
		GObject item;		
		int i = grfliste.getSelectedIndex();
		anzTimer++;
		if (anzTimer > 50) {
			myTimer.stop(); //
			if ((liste.size() > 0) && (i >= 0)) {
				// alle anschalten, Problem klicken in Liste
				for (int j = 0; j < liste.size(); j++) {
					item = liste.get(j);
					item.bEnabled = true;
				}
				grafik.updateUI();
			}
			myTimer = null;
		} else {
			if ((liste.size() > 0) && (i >= 0)) {
				item = liste.get(i);
				item.bEnabled = !item.bEnabled;
				// alle anderen anschalten
				for (int j = 0; j < liste.size(); j++) {
					item = liste.get(j);
					if (j!=i) item.bEnabled = true;
				}
				grafik.updateUI();				
			}
		}
	}

	private void deleteItem() {
		GObject item;
		int i = grfliste.getSelectedIndex();
		if ((liste.size() > 0) && (i >= 0)) {
			item = liste.get(i);
			liste.remove(i);
			grfliste.setListData(liste);
			grfliste.updateUI();
		}
	}

	private void ChangeTop() {
		GObject item;
		int i = grfliste.getSelectedIndex();
		if ((liste.size() > 0) && (i > 0)) {
			item = liste.get(i);
			liste.remove(i);
			liste.insertElementAt(item, i - 1);
			grfliste.setListData(liste);
			grfliste.updateUI();
		}
	} // ChangeTop

	private void ChangeDown() {
		GObject item;
		int i = grfliste.getSelectedIndex();
		if ((liste.size() > 0) && (i < (liste.size() - 1))) {
			item = liste.get(i);
			liste.remove(i);
			liste.insertElementAt(item, i + 1);
			grfliste.setListData(liste);
			grfliste.updateUI();
		}
	} // ChangeDown

	private void ChangeFlash() {
		if (myTimer == null) {
			anzTimer = 0;
			myTimer = new Timer(200, this); // 200 ms
			myTimer.start(); // starten
		}
	}

	private void openFile() {
		JFileChooser jFileChooser1 = new JFileChooser();
		MyFileFilter grfFilter;
		grfFilter = new MyFileFilter("grf", "Grafik-Datei (*.grf)");

		jFileChooser1.setMultiSelectionEnabled(false);
		jFileChooser1.setCurrentDirectory(new File((String) System
				.getProperties().get("user.dir")));

		jFileChooser1.addChoosableFileFilter(grfFilter);
		if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
			// Rufen Sie openFile auf, um Text aus einer Datei in die TextArea
			// zu laden
			sFileName = jFileChooser1.getSelectedFile().getPath();
			loadFile();
		}
	}

	private void loadFile() {
		FileInputStream fis;
		ObjectInputStream ois = null;
		GObject item;

		try {
			setTitle(sFileName);
			fis = new FileInputStream(sFileName);
			ois = new ObjectInputStream(fis);
			Integer I = (Integer) ois.readObject();
			liste.clear();
			for (int i = 0; i < I.intValue(); i++) {
				item = (GObject) ois.readObject();
				addGrafik(item);
			}

			ois.close();
			System.out.println(" Ende des Lesens ");
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (ois != null) {
				try {
					ois.close();
				} catch (IOException ioe) {
				}
			}
		}

	} // loadFile

	private void saveFile() {
		JFileChooser jFileChooser1 = new JFileChooser();
		MyFileFilter grfFilter;
		grfFilter = new MyFileFilter("grf", "Grafik-Datei (*.grf)");

		jFileChooser1.setMultiSelectionEnabled(false);
		jFileChooser1.setCurrentDirectory(new File((String) System
				.getProperties().get("user.dir")));

		jFileChooser1.addChoosableFileFilter(grfFilter);
		if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
			// Rufen Sie openFile auf, um Text aus einer Datei in die TextArea
			// zu laden
			sFileName = jFileChooser1.getSelectedFile().getPath();
			if (!sFileName.toLowerCase().endsWith(".grf")) {
				sFileName += ".grf";
			}
			setTitle(sFileName);
			saveGraphics();
		}

	}

	private void saveGraphics() {
		FileOutputStream fout;
		ObjectOutputStream oos = null;

		try {
			fout = new FileOutputStream(sFileName);
			oos = new ObjectOutputStream(fout);
			Integer I = new Integer(liste.size());
			oos.writeObject(I);
			for (int i = 0; i < liste.size(); i++) {
				GObject item = liste.get(i);
				oos.writeObject(item);
			}

			oos.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (oos != null) {
				try {
					oos.flush();
				} catch (IOException ioe) {
				}
				try {
					oos.close();
				} catch (IOException ioe) {
				}
			}
		}

	} // save

	private void addGrafik(GObject gobj) {
		liste.add(gobj);
		grafik.updateUI();
		grfliste.setListData(liste);
		grfliste.updateUI();
	}

	private void Test() {
		Circle circle = new Circle(100, 100, 50);
		addGrafik(circle);
		Rect rect = new Rect(150, 100, 400, 300);
		addGrafik(rect);
		Line line = new Line(200, 100, 340, 400);
		addGrafik(line);

	}

	public void insertGraphic(int x1, int y1, int x2, int y2) {
		Line line;
		Rect rect;
		Circle circle;
		if (BnLine.isSelected()) {
			line = new Line(x1, y1, x2, y2);
			addGrafik(line);
		}
		if (BnCircle.isSelected()) {
			circle = new Circle(x1,y1,x2,y2);
			addGrafik(circle);
		}
		if (BnRect.isSelected()) {
			rect = new Rect(x1, y1, x2, y2);
			addGrafik(rect);
		}
	}

	public static void main(String[] args) {
		JPaint frame = new JPaint("MI ist toll");

	}

}
